////////////////////////////////////////////////////////////////////////////////
//
//  Nombre         : BackPer.prg
//  Description    : Este programa genera un .zip cada n minutos
//                   todos los archivos .prg (se puede cambiar)
//                   contenidos en una carpeta ORIGEN
//                   dejando el zip en una carpeta DESTINO
//                   el programa se puede parametrizar a traves
//                   de .ini
//  Autor          : Ismach ( farfan890@gmail.Com )
//  ---------------------------------------------------------------*
//  Proyecto       :
// ----------------------------------------------------------------*
//  Compile        : \compile.bat BackPer% /l hbziparc /l hbmzip /l minizip /l hbzlib
//  Enlace Binario :
//  ************************************************************** *
//  Salidas        : .ZIP
//  ************************************************************** *
//
//
//
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
#include "minigui.ch"

#define FinLinea  Chr(10) + Chr(13)

#define NOMSYS    "BackPer"
#define VERSYS    "Version 1.01.99(R)"

#define SISTEMA   NOMSYS + " " + VERSYS
#define Autor     "Ismach"

DECLARE WINDOW wnavan

STATIC cMinutos  := "10"
STATIC cFoldOr   := "c:\OOHG\source"
STATIC cFoldDe   := "c:\temp"
STATIC cFiltro   := "*.prg"
STATIC cPrefix   := "Backper_"

////////////////////////////////////////////////////////////////////////////////
PROCEDURE Main()
////////////////////////////////////////////////////////////////////////////////

     PUBLIC bHideShow := { || iif(IsWindowVisible( GetFormHandle( 'wnavan' ) ), wnavan.Hide, wnavan.Show ) }

     PUBLIC aConfig
     PUBLIC cMinutos
     PUBLIC cFoldOr
     PUBLIC cFoldDe
     PUBLIC cFiltro
     PUBLIC cPrefix
     PUBLIC ccDate    := Date()
     PUBLIC ccDateBkp := ccDate
     PUBLIC nMinutos  := 0
     PUBLIC cNameFileZip
     bHideShow := { || iif(IsWindowVisible( GetFormHandle( 'wnavan' ) ), wnavan.Hide, wnavan.Show ) }

     SET CENTURY ON
     SET DATE FRENCH
     SET DATE FORMAT "yyyymmdd"
     REQUEST HB_LANG_ESWIN
     HB_LANGSELECT( "ESWIN" )


     ccDate    := Date()
     ccDateBkp := ccDate

     cMinutos  := "10"
     cFoldOr   := "c:\OOHG\source"
     cFoldDe   := "c:\temp"
     cFiltro   := "*.prg"
     cPrefix   := "Backper_"

     aConfig   := { { "Minutos" , "10"             } , ;
                    { "Origen"  , "C:\OOHG\source" } , ;
                    { "Destino" , "C:\temp"        } , ;
                    { "Filtro"  , "*.prg"          } , ;
                    { "Prefix"  , "Backper_"       } }
     GetConfig()

     DEFINE WINDOW wnmain AT 0,0 WIDTH 0 HEIGHT 0 ;
            ICON 'BackPer.ico' ;
            MAIN NOSHOW ;
            ON INIT BackupPerm() ;
            NOTIFYICON 'BackPer.ico' ;
            NOTIFYTOOLTIP 'Backup Permanente' ;
            ON NOTIFYCLICK Eval( bHideShow )

            DEFINE NOTIFY MENU
                   MENUITEM "Ocultar/Mostrar" ACTION Eval( bHideShow )
                   MENUITEM "Autor"  ACTION IsmachShow()
                   SEPARATOR
                   MENUITEM "Cerrar" ACTION wnmain.Release
            END MENU

     END WINDOW
     wnmain.Activate

RETURN

////////////////////////////////////////////////////////////////////////////////
STATIC PROCEDURE BackupPerm( nCaller )
////////////////////////////////////////////////////////////////////////////////
     STATIC lIsColon   := .T. ,;
            lSound     := .T. ,;
            lSeconds   := .T. ,;
            aLMetrcs   := { { 40, 10, 40, 10, 40 }, { 25, 40, 10, 40, 25 } }

     LOCAL cFrmName    := '' ,;
           aCCPrpArray := ARRAY( 5 ),;
           cCurTime    := TIME(),;
           aTmpColor   := {},;
           nLblType    := 0,;
           nlblRow     := 5,;
           nlblWidth   := 0,;
           nDigit      := 0,;
           cDigit      := ''

     IF HB_ISNIL( nCaller )

          IF  IsWindowDefined('wnavan')
              RETURN NIL
          ENDIF

          DEFINE WINDOW wnavan AT GetDesktopHeight() - 75 - GetTaskBarHeight(), GetDesktopWidth() - 250 ;
                 WIDTH  245 HEIGHT  50 TITLE 'Backup Permanente' ;
                 CHILD NOCAPTION NOSIZE NOMAXIMIZE ;
                 BACKCOLOR BLUE ;
                 TOPMOST ;
                 ON MOVE CoordsCorr() ;
                 ON INIT BackupPerm( 0 ) ;
                 ON RELEASE Nil

                 // ON KEY ESCAPE ACTION ReleaseAllWindows()


              DEFINE TIMER tmrClock INTERVAL 10000 ACTION BackupPerm( 5 )
              DEFINE PROGRESSBAR pgbar
                  ROW 08
                  COL 07
                  WIDTH 230
                  HEIGHT 15
                  RANGEMIN 0
                  RANGEMAX 10
                  VALUE 0
                  FORECOLOR {0,130,0}
              END PROGRESSBAR

              @25,007 LABEL lblfile HEIGHT 15 WIDTH 230 VALUE 'aqui van los archivos a backpear' FONT "Tahoma" SIZE 08 CENTERALIGN TRANSPARENT FONTCOLOR WHITE

              DEFINE CONTEXT MENU
                  MENUITEM "Preferences"  ACTION ShowWinConfig()
                  MENUITEM "Ocultar"      ACTION wnavan.Hide
                  SEPARATOR
                  MENUITEM "Cerrar (Escape)"  ACTION ReleaseAllWindows()
              END MENU

          END WINDOW
          wnavan.Activate

     ELSE

        IF  nCaller = 5
            StartBackups()
        ENDIF

     ENDIF

RETURN

//////////////////////////////////////////////////////////////////////
//
//
//
//////////////////////////////////////////////////////////////////////
STATIC FUNCTION ShowWinConfig()

     DEFINE WINDOW wnconf AT 00,00 WIDTH 440 HEIGHT 180 ;
            TITLE "Config BackPer" ;
            MODAL

            @001,001 GRID gridback WIDTH 330 HEIGHT 160 ;
                     HEADERS {"Item","Valor"} ;
                     WIDTHS {120,205} ;
                     ITEMS aConfig ;
                     VALUE 0 ;
                     FONT "Consolas" SIZE 12 ;
                     BACKCOLOR { 255, 255, 128 }

            @010,340 BUTTON cmdsave CAPTION '&Grabar' ;
                     WIDTH 80 HEIGHT 25 ;
                     FLAT ;
                     ACTION SaveSetting()

            @040,340 BUTTON cmdclose CAPTION '&Cerrar' ;
                     WIDTH 80 HEIGHT 25 ;
                     FLAT ;
                     ACTION wnconf.Release()


     END WINDOW
     wnconf.Center
     wnconf.Activate

RETURN Nil


////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION CloseAll()
////////////////////////////////////////////////////////////////////////////////

     SaveSetting()
     wnmain.Release

RETURN NIL

////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION SaveSetting()
////////////////////////////////////////////////////////////////////////////////

     BEGIN INI FILE ChangeFileExt( hb_ProgName(), '.ini' )

         SET SECTION 'BACKUP' ENTRY  "Minutos"  TO cMinutos
         SET SECTION 'BACKUP' ENTRY  "Origen"   TO cFoldOr
         SET SECTION 'BACKUP' ENTRY  "Destino"  TO cFoldDe
         SET SECTION 'BACKUP' ENTRY  "Filtro"   TO cFiltro
         SET SECTION 'BACKUP' ENTRY  "Prefix"   TO cPrefix


     END INI
     Inkey(1)
     IF IsWindowDefined('wnconf')
         wnconf.Release()
     ENDIF

RETURN NIL
////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION GetConfig()
////////////////////////////////////////////////////////////////////////////////
     
     //SI NO EXISTE GRABAR UN ARCHIVO DE CONFIGURACION POR DEFECTO

     IF  !FILE( ChangeFileExt( hb_ProgName(), '.ini' ))
         SaveSetting()
     ENDIF

     BEGIN INI FILE ChangeFileExt( hb_ProgName(), '.ini' )

           GET cMinutos  SECTION "BACKUP" ENTRY "Minutos"    DEFAULT "10"
           GET cFoldOr   SECTION "BACKUP" ENTRY "Origen"     DEFAULT "c:\OOHG\source"
           GET cFoldDe   SECTION "BACKUP" ENTRY "Destino"    DEFAULT "c:\temp"
           GET cFiltro   SECTION "BACKUP" ENTRY "Filtro"     DEFAULT "*.prg"
           GET cPrefix   SECTION "BACKUP" ENTRY "Prefix"     DEFAULT "Backper_"

           nMinutos := Val( cMinutos )

     END INI

RETURN Nil

////////////////////////////////////////////////////////////////////////////////
STATIC FUNCTION StartBackups()
////////////////////////////////////////////////////////////////////////////////
     LOCAL ccTime       := Time()
     LOCAL ccDateBkp    := DToc( Date() ) + '_'

     Local aDir
     Local aFiles:= {}
     Local cZPathfile
     LOCAL cPath, nPos


     ccTime :=  SubStr(ccTime,1,2) + SubStr(ccTime,4,2) + SubStr(ccTime,7,2)

     ccDateBkp    := DToc( Date() ) + '_' + ccTime + '.zip'
     cNameFileZip := cPrefix + ccDateBkp

     GetConfig()

     IF  Empty(cFoldOr)
         cFoldOr := GetFolder("Carpeta Origen", GetCurrentFolder() )
     ENDIF

     IF  Empty(cFoldDe)
         cFoldDe := GetFolder("Carpeta Destino", GetCurrentFolder() )
     ENDIF

     IF  Empty(cFoldOr) .or.  Empty(cFoldDe)
         RETURN NIL
     ENDIF

     IF  EMPTY( cFiltro )
          cFiltro := "*.*"
     ENDIF

     IF  nMinutos < 1
         nMinutos :=  10
         cMinutos := "10"

     ENDIF

     IF  cFoldOr == cFoldDe .and. cFiltro == "*.*"
         MSGINFO("No se puede Backupear *.* sobre mismos origen y destino","ERROR")
         RETURN NIL
     ENDIF

     SET DEFAULT TO  cFoldOr

     CreateZip( cFoldOr )

RETURN Nil

////////////////////////////////////////////////////////////////////////////////
Function CreateZip( xccPath )
////////////////////////////////////////////////////////////////////////////////

     Local aDir := Directory( "*.prg", "D" ), aFiles:= {}, nLen
     Local cPath := CurDrive()+":\"+CurDir()+"\"
     Local x

     cFoldOr := Alltrim( cFoldOr )
     IF  !ENDSWITH( cFoldOr, "\" )
          cFoldOr := cFoldOr + "\"
     ENDIF

     IF  ( !DIRCHANGE( cFoldOr )==0 )
         MSGINFO("No se puede Leer el Directorio Origen","ERROR")
         RETURN NIL
     ENDIF

     aFiles:= {}

     aDir  :=Directory( cFiltro )

     For  x:=1 TO len(aDir) Step 1

          AADD( afiles, aDir[ x, 1 ] )

     Next x

     cFoldDe := Alltrim( cFoldDe )
     IF  !ENDSWITH( cFoldDe, "\" )
          cFoldDe := cFoldDe + "\"
     ENDIF

     cNameFileZip := cFoldDe + cNameFileZip

     IF ( nLen := Len(aFiles) ) > 0

             wnavan.pgbar.RangeMin := 1
             wnavan.pgbar.RangeMax := len(aFiles)
             MODIFY CONTROL lblfile OF wnavan FONTCOLOR {230,230,0}

                COMPRESS aFiles ;
                        TO cNameFileZip ;
                        BLOCK {|cFile, nPos| ProgressUpdate( nPos, cFile, .T. ) } ;
                        LEVEL 9 ;
                        OVERWRITE ;
                        STOREPATH ;
                        FILEPROGRESS {|nPos, nTotal| ProgressFile( nPos, nTotal, .T. ) } ;
                        RESULT lSuccess


             wnavan.lblfile.Value := 'Backup finalizado'
             // wnavan.tmrClock.Value := 1000
             Eval( bHideShow )
             inkey(1)
             // wnavan.tmrClock.Value := 1000
             Eval( bHideShow )
     ENDIF
     wnavan.tmrClock.Value := nMinutos * 60000

RETURN Nil

////////////////////////////////////////////////////////////////////////////////
FUNCTION ProgressUpdate( nPos , cFile , lShowFileName )
////////////////////////////////////////////////////////////////////////////////

        Default lShowFileName := .F.

        wnavan.pgbar.Value    := nPos
        wnavan.lblfile.Value  := cFileNoPath( cFile )

RETURN NIL

////////////////////////////////////////////////////////////////////////////////
Function ProgressFile( nPos , nTotal , lShowFileProgress )
////////////////////////////////////////////////////////////////////////////////

        Default lShowFileProgress := .F.

        wnavan.pgbar.Value := ( nPos / nTotal ) * 100

Return Nil

////////////////////////////////////////////////////////////////////////////////
STATIC PROCEDURE CoordsCorr()
////////////////////////////////////////////////////////////////////////////////
     LOCAL nTop  := wnavan.Row
     LOCAL nLeft := wnavan.Col

     IF  nTop < 0
         SetProperty( 'wnavan', 'Row', 0 )
     ENDIF

     IF  nLeft < 0
         SetProperty( 'wnavan', 'Col', 0 )
     ENDIF

     IF  nTop + 75 > GetDesktopHeight() - GetTaskBarHeight()
         SetProperty( 'wnavan', 'Row', GetDesktopHeight() - 75 - GetTaskBarHeight() )
     ENDIF

     IF  nLeft + 150 > GetDesktopWidth()
         SetProperty( 'wnavan', 'Col', GetDesktopWidth() - 150 )
     ENDIF

RETURN

////////////////////////////////////////////////////////////////////////////////
FUNCTION EndSwith( cInString, cCompareString )
////////////////////////////////////////////////////////////////////////////////
RETURN ( cCompareString == RIGHT( cInString, LEN( cCompareString ) ) )

////////////////////////////////////////////////////////////////////////////////
Static FUNCTION IsmachShow()
////////////////////////////////////////////////////////////////////////////////
    Local  cSent:= SISTEMA + FinLinea + FinLinea + ;
                   "Desarrollado por :" + FinLinea + FinLinea + ;
                   Autor + FinLinea + FinLinea + ;
                   "Buenos Aires - Argentina"

    MsgInfo(cSent, SISTEMA)

RETURN NIL
